' AlGaAs.bas for FilmStar INDEX
' Copyright FTG Software Dec 2019
Option Explicit
DefInt I-N
DefDbl A-H, O-Z
'https://www.batop.de/information/n_AlGaAs.html
Dim xAl, wave
Const bTest As Boolean = False

Sub Main
    Dim xn, s$
    If bTest Then
        wave = 900     ' nm
        xAl = 50       ' % fraction Al
    Else
        s$ = Clipboard$()
        Parse s$, wave
        Parse s$, xAl   ' only one coefficient A
    End If
    xAl = .01 * xAl     ' xAl in %
    xn = Sqr((6.3 + 19 * xAl) * (f(chi) + .5 * f(chiso) *(e0/e0d)^1.5) + (9.4-10.2*xAl))
    If bTest Then
        Debug.Print xn
    Else
        Clipboard$ Format$(xn, "0.00000") & ",0"    ' k = 0
    End If
End Sub

Function f(ByVal c)
    On Error Resume Next
    f = (2-Sqr(1 + c) - Sqr(1 - c))/(c*c)
End Function

Function chi()
    chi = 1239.84193/(wave * e0)
End Function

Function chiso()
    chiso = 1239.84193/(wave * e0d)
End Function

Function e0()
    e0 = 1.425 + xAl * (1.155 + .37 * xAl)
End Function

Function e0d()
    e0d = 1.765 + xAl * (1.115 + .37 * xAl)
End Function

Sub Parse (s$, x)
    Dim i
    i = InStr(s$, ",")  ' comma delimited
    x = Val(Mid$(s$, 1, i - 1))
    s$ = Mid$(s$, i + 1)
End Sub
