' RefractiveIndexInfo.bas for FilmStar INDEX
' Copyright 2010-2015 FTG Software Associates

' Imports 'Tabulated data (n,k)' tables from http://RefractiveIndex.Info
' Right click CSV link and save in directory Path$
' Updated 30 Jul 2015 for new format

Const Path$ = "C:\Winfilm\RefractiveIndexInfo"

Option Explicit
Option Base 1
DefInt i-N
DefSng A-H, o-Z

Sub Main
    Dim i, k, kFN, File$, d$, s$, xnData#(), xkData#()
    File$ = GetFilePath(, "csv", Path$, "Open RefractiveIndex.INFO n,k File")
    If Len(File$) > 0 Then
        On Error GoTo OpenError
        kFN = FreeFile
        Open File$ For Input As #kFN
        Line Input #kFN, s$
        If s$ <> "wl,n" Then
            MsgBox "Not RefractiveIndex.INFO file or missing n data", vbCritical, "File Open Error"
            Close #kFN
            End
        End If
        i = 1
        ReDim xkData(2, 1)  ' in case k=0
        Do While Not EOF(kFN)
            Line Input #kFN, s$
            If s$ = "" Then
                Line Input #kFN, s$
                If s$ = "wl,k" Then
                    GoTo getKdata
                Else
                    GoTo closefile
                End If
            End If
            ReDim Preserve xnData#(2, i)
            k = InStr(s$, ",")
            xnData(1, i) = Val(Mid$(s$, 1, k - 1))
            xnData(2, i) = Val(Mid$(s$, k + 1))
            i = i + 1
        Loop
        GoTo CloseFile

GetKdata:
        On Error GoTo OpenError
        i = 1
        Do While Not EOF(kFN)
            Line Input #kFN, s$
            k = InStr(s$, ",")
            ReDim Preserve xkData#(2, i)
            xkData(1, i) = Val(Mid$(s$, 1, k - 1))
            xkData(2, i) = Val(Mid$(s$, k + 1))
            i = i + 1
        Loop

CloseFile:
        Close #kFN
        IndexConvertK xndata(), xkData(), 1000
        TablePlot
        AutoAxes True
        IndexName$ = FileName$(File$)
        FileSave    ' save in FilmStar format
    End If
    Exit Sub
OpenError:
    Close #kFN
    MsgBox Err.Description, vbCritical, "File Open Error"
End Sub

Function FileName$(ByVal f$)
    Dim k, r$
    r$ = StrReverse(f$)
    k = Len(f$) - InStr(r$, "\") + 1
    FileName$ = Mid$(f$, k + 1)
    FileName$ = Left$(FileName$, Len(FileName$) - 4)
End Function
